-- name: [CS] Dave Strider
-- description: There's this really cool dude, ok? He's standing around being all chill, like cool dudes are known to do sometimes. A cool dude like this probably has a real cool name. But he probably wouldn't just tell you what it was if you asked. He'd be way too busy for that. Busy being totally sweet.
--[[API Documentation for Character Select can be found below:
https://github.com/Squishy6094/character-select-coop/wiki/API-Documentation]]

--- MODEL ---
local E_MODEL_DAVE = smlua_model_util_get_id("dave_geo")
local E_MODEL_DAVELOHACSE = smlua_model_util_get_id("davelohacse_geo")
local E_MODEL_DAVEPLUSHTUX = smlua_model_util_get_id("daveplushtux_geo")
local E_MODEL_DAVEWHITETUX = smlua_model_util_get_id("davewhitetux_geo")
local E_MODEL_DAVEGODTIER = smlua_model_util_get_id("davegodtier_geo")

--- ICON ---
local TEX_ICON_DAVE = get_texture_info("dave-icon")
local TEX_ICON_DAVELOHACSE = get_texture_info("dave-icon")
local TEX_ICON_DAVEPLUSHTUX = get_texture_info("dave-icon")
local TEX_ICON_DAVEWHITETUX = get_texture_info("dave-icon")
local TEX_ICON_DAVEGODTIER = get_texture_info("dave-icon")

local falling_sounds = {}
for i = 1, 412 do
    falling_sounds[i] = 'DaveFalling.ogg'
end
falling_sounds[413] = 'DaveFallingRare.ogg'

--[[
local falling_sounds = {}
for i = 1, 412 do
    falling_sounds[i] = 'DaveFalling.ogg'
end
falling_sounds[413] = 'DaveFallingRare.ogg'
]]


--- VOICE ---
local CUSTOM_VOICETABLE_DAVE = {
    [CHAR_SOUND_OKEY_DOKEY] =        'DaveStartGame.ogg', -- Starting game
	[CHAR_SOUND_LETS_A_GO] =         'DaveStartLevel.ogg', -- Starting level
	[CHAR_SOUND_PUNCH_YAH] =         'DavePunch1.ogg', -- Punch 1
	[CHAR_SOUND_PUNCH_WAH] =         'DavePunch2.ogg', -- Punch 2
	[CHAR_SOUND_PUNCH_HOO] =         'DavePunch3.ogg', -- Punch 3
	[CHAR_SOUND_YAH_WAH_HOO] =       {'DaveJump1.ogg', 'DaveJump2.ogg', 'DaveJump3.ogg'}, -- First Jump Sounds
	[CHAR_SOUND_HOOHOO] =            'DaveDoubleJump.ogg', -- Second jump sound
	[CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {'DaveTripleJump1.ogg', 'DaveTripleJump2.ogg'}, -- Triple jump sounds
	[CHAR_SOUND_UH] =                'DaveBonk.ogg', -- Wall bonk
	[CHAR_SOUND_UH2] =               'DaveLongJumpLand.ogg', -- Landing after long jump
	[CHAR_SOUND_UH2_2] =             'DaveLongJumpLand2.ogg',
	[CHAR_SOUND_HAHA] =              'DaveTripleJumpLand.ogg', -- Landing triple jump
	[CHAR_SOUND_YAHOO] =             'DaveLongJump.ogg', -- Long jump
	[CHAR_SOUND_DOH] =               'DaveLongJumpBonk.ogg', -- Long jump wall bonk
	[CHAR_SOUND_WHOA] =              'DaveGrabLedge.ogg', -- Grabbing ledge
	[CHAR_SOUND_EEUH] =              'DaveClimbLedge.ogg', -- Climbing over ledge
    [CHAR_SOUND_WAAAOOOW] =          falling_sounds,
    [CHAR_SOUND_TWIRL_BOUNCE] =      'DaveFlowerBounce.ogg', -- Bouncing off of a flower spring
	[CHAR_SOUND_GROUND_POUND_WAH] =  'DaveGroundPound.ogg', 
	[CHAR_SOUND_HRMM] =              'DaveLift.ogg', -- Lifting something
	[CHAR_SOUND_HERE_WE_GO] =        'DaveGetStar.ogg', -- Star get
	[CHAR_SOUND_SO_LONGA_BOWSER] =   'DaveThrowBowser.ogg', -- Throwing Bowser
--DAMAGE
	[CHAR_SOUND_ATTACKED] = 'DaveDamaged.ogg', -- Damaged
	[CHAR_SOUND_PANTING] = 'DavePanting.ogg', -- Low health
	[CHAR_SOUND_ON_FIRE] = 'DaveBurned.ogg', -- Burned
--SLEEP SOUNDS
	[CHAR_SOUND_IMA_TIRED] = 'DaveTired.ogg', -- Mario feeling tired
	[CHAR_SOUND_YAWNING] = 'DaveYawn.ogg', -- Mario yawning before he sits down to sleep
	[CHAR_SOUND_SNORING1] = 'DaveSnore.ogg', -- Snore Inhale
	[CHAR_SOUND_SNORING2] = 'DaveExhale.ogg', -- Exhale
	[CHAR_SOUND_SNORING3] = 'DaveSleepTalk.ogg', -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
	[CHAR_SOUND_COUGHING1] = 'DaveCough1.ogg', -- Cough take 1
	[CHAR_SOUND_COUGHING2] = 'DaveCough2.ogg', -- Cough take 2
	[CHAR_SOUND_COUGHING3] = 'DaveCough3.ogg', -- Cough take 3
--DEATH
	[CHAR_SOUND_DYING] = 'DaveDying.ogg', -- Dying from damage
	[CHAR_SOUND_DROWNING] = 'DaveDrowning.ogg', -- Running out of air underwater
	[CHAR_SOUND_MAMA_MIA] = 'DaveLeaveLevel.ogg' -- Booted out of level
}

--- CHARACTER ---
if _G.charSelectExists then
    -- Add the main character
    local dave_id = _G.charSelect.character_add(
        "Dave Strider",
        {"its like shit wants nothing to do with that hook", " "},
        "TheEnderDwonk",
        {r = 224, g = 7, b = 7},
        E_MODEL_DAVE,
        CT_MARIO,
        TEX_ICON_DAVE
    )

  _G.charSelect.character_add_costume(
        dave_id,
        "Dave (LOHACSE)",
        {"The economy belongs to you.", " "},
        "TheEnderDwonk",
        {r = 224, g = 7, b = 7},
        E_MODEL_DAVELOHACSE,
        CT_MARIO,
        TEX_ICON_DAVELOHACSE
    )

  _G.charSelect.character_add_costume(
        dave_id,
        "Dave (Plush Tux)",
        {"It is like walking around in snugly pajamas.", " "},
        "TheEnderDwonk",
        {r = 224, g = 7, b = 7},
        E_MODEL_DAVEPLUSHTUX,
        CT_MARIO,
        TEX_ICON_DAVEPLUSHTUX
    )
	
	  _G.charSelect.character_add_costume(
        dave_id,
        "Future Dave",
        {"ok its me from the future", " "},
        "TheEnderDwonk",
        {r = 224, g = 7, b = 7},
        E_MODEL_DAVEWHITETUX,
        CT_MARIO,
        TEX_ICON_DAVEWHITETUX
    )
	
		  _G.charSelect.character_add_costume(
        dave_id,
        "Dave (God Tier)",
        {"the dead daves are piling up", " "},
        "TheEnderDwonk",
        {r = 224, g = 7, b = 7},
        E_MODEL_DAVEGODTIER,
        CT_MARIO,
        TEX_ICON_DAVEGODTIER
    )

    -- Add custom voice
    _G.charSelect.character_add_voice(E_MODEL_DAVE, CUSTOM_VOICETABLE_DAVE)
	
    _G.charSelect.character_add_voice(E_MODEL_DAVELOHACSE, CUSTOM_VOICETABLE_DAVE)
	
    _G.charSelect.character_add_voice(E_MODEL_DAVEPLUSHTUX, CUSTOM_VOICETABLE_DAVE)
	
    _G.charSelect.character_add_voice(E_MODEL_DAVEWHITETUX, CUSTOM_VOICETABLE_DAVE)
	
    _G.charSelect.character_add_voice(E_MODEL_DAVEGODTIER, CUSTOM_VOICETABLE_DAVE)	
	

    -- Hook events for the character's custom behavior
    hook_event(HOOK_CHARACTER_SOUND, function(m, sound)
        if _G.charSelect.character_get_voice(m) == CUSTOM_VOICETABLE_DAVE then
            return _G.charSelect.voice.sound(m, sound)
        end
    end)

    hook_event(HOOK_MARIO_UPDATE, function(m)
        if _G.charSelect.character_get_voice(m) == CUSTOM_VOICETABLE_DAVE then
            return _G.charSelect.voice.snore(m)
        end
    end)
end
